﻿namespace TabsStudioOpenNext
{
    public class OpenNext : TabsStudioExt.ITabsStudioAddin
    {
        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine_, EnvDTE80.DTE2 dte)
        {
            engine = engine_;
            isPreviewTabProperty = new TabsStudioExt.Util.IsPreviewTabProperty();
            engine.TabCreated += OnTabCreated;
        }

        public void OnDisconnection()
        {
            engine.TabCreated -= OnTabCreated;
        }

        private void OnTabCreated(object sender, TabsStudioExt.TabEventArgs e)
        {
            if (isPreviewTabProperty.IsPreviewTab(e.Tab.TabItem))
                return;

            foreach (System.Windows.Controls.TabItem tabItem in e.Tabs.TabPanel2.Children)
            {
                if (tabItem != e.Tab.TabItem && IsTabSelected(tabItem, e.Tabs))
                {
                    e.Tabs.TabPanel2.Children.Remove(e.Tab.TabItem);
                    e.Tabs.TabPanel2.Children.Insert(e.Tabs.TabPanel2.Children.IndexOf(tabItem) + 1, e.Tab.TabItem);
                    break;
                }
            }
        }

        private bool IsTabSelected(System.Windows.Controls.TabItem tabItem, TabsStudioExt.Tabs tabs)
        {
            foreach (TabsStudioExt.Tab tab in tabs.TabList)
            {
                if (tab.IsTabSelected || tab.TabItem == tabItem)
                    return tab.IsTabSelected && tab.TabItem == tabItem;
            }
            return false;
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private TabsStudioExt.Util.IsPreviewTabProperty isPreviewTabProperty;
    }
}
